/* ------------------------------ */
/* unix to Dos by Philippe Jounin */
/* ------------------------------ */

#include <stdio.h>


int Convert (char *szFile)
{
#define XX_RETURN(s,x) \
{  printf ("%s\n", s) ; if (pFIn!=NULL) fclose(pFIn) ; \
   if (pFOut!=NULL)   fclose(pFOut);                   \
   if (TmpFile!=NULL) remove(TmpFile);                 \
   return x;   }
   
char *TmpFile=NULL;
int   c;
FILE *pFIn=NULL, *pFOut=NULL;

   printf ("%s\t", szFile);  fflush (stdout);
   TmpFile = tmpnam(NULL); 
   if (TmpFile==NULL) XX_RETURN ("Can not create temporary file", -1);
   pFOut = fopen (TmpFile, "w");
   if (pFOut==NULL) XX_RETURN ("Can not create temporary file", -2);
   pFIn = fopen (szFile, "r");
   if (pFIn==NULL) XX_RETURN ("Can not open input file", -3);
   
   while ( (c=fgetc (pFIn)) != EOF)
     { if (fputc (c, pFOut)==EOF)  XX_RETURN ("Can not write into output file", -4); }
   if (!feof (pFIn))  XX_RETURN ("Can not read from input file", -5);
   
   fclose (pFIn); fclose (pFOut);
   if (remove (szFile))  XX_RETURN ("Can not rename output file", -6);
   if (rename (TmpFile, szFile)==-1)
   { printf ("input file %s removed, temp file %s can not be removed\n", 
   		      szFile, TmpFile);
     return -8; }
   
return 0;
   
} /* Convert */

int main (int argc, char *argv[])
{
  if (argc<2) 
    { 
       printf ("Usage: u2d file [file [...]]\n"
               "Translate a unix text file. Existing file is overwritten\n");
    }
  else
  {int Ark;
     for (Ark=1 ;  Ark<argc ; Ark++)
        Convert (argv[Ark]);
  }
return 0;       
} /* main */
